
#include <Keypad.h>                      //import keypad library

#include <Wire.h>  
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x3F,20, 4);

const byte ROWS = 4;                    // four rows
const byte COLS = 4;                    // four columns
boolean valOnePresent = false;
boolean next = false;
boolean final = false;
String num1, num2;
int ans;
char op;


char keys [ROWS] [COLS] = {             // define he keypad
  {'1', '2', '3', '+'},
  {'4', '5', '6', '-'},
  {'7', '8', '9', 'X'},
  {'*', '0', '/', '='}
};

byte rowPins[ROWS] = {13 ,12 ,11 ,10}; //connect keypad ROW1, ROW2, ROW3, ROW4 to these arduino pins
byte colPins[COLS] = {9, 8, 7, 6};     //connect keypad COL1, COL2, COL3, COL4 to these arduino pins

Keypad myKeypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );  //creating keypad

void setup()
{
  lcd.init();
  lcd.backlight();          // makes Backligh ON. 
  lcd.clear();              // Clears LCD
  lcd.setCursor(5, 0);
  lcd.print("Arduino");     //display on LCD after code upload
  lcd.setCursor(3, 1);
  lcd.print("Calculator");
  delay(2000);
  lcd.clear(); 
  
}

void loop()
{
  char key = myKeypad.getKey();
  if (key != NO_KEY && (key=='1'||key=='2'||key=='3'||key=='4'||key=='5'||key=='6'||key=='7'||key=='8'||key=='9'||key=='0'))
  {
    if (valOnePresent != true)
    {
      num1 = num1 + key;
      int numLength = num1.length();
      lcd.setCursor(15 - numLength, 0); //to adjust one whitespace for operator
      lcd.print(num1);
    }
    else 
    {
      num2 = num2 + key;
      int numLength = num2.length();
      lcd.setCursor(15 - numLength, 1);
      lcd.print(num2);
      final = true;
    }
  }
  else if (valOnePresent == false && key != NO_KEY && (key == '/' || key == '*' || key == '-' || key == '+'))
  {
    if (valOnePresent == false)
    {
      valOnePresent = true;
      op = key;
      lcd.setCursor(15,0); //operator on right corner
      lcd.print(op);
    }
  }
  else if (final == true && key != NO_KEY && key == '=')
  {
    if (op == '+')
    {
      ans = num1.toInt() + num2.toInt();
    }
    else if (op == '-')
    {
      ans = num1.toInt() - num2.toInt();
    }
    else if (op == '*')
    {
      ans = num1.toInt() * num2.toInt();
    }
    else if (op == '/')
    {
      ans = num1.toInt() / num2.toInt();
    }    
    
    lcd.clear();
    lcd.setCursor(15,0);
    lcd.autoscroll();
    lcd.print(ans);
    lcd.noAutoscroll();
  }
  else if (key != NO_KEY && key == 'X')
  {
    lcd.clear();
    valOnePresent = false;
    final = false;
    num1 = "";
    num2 = "";
    ans = 0;
    op = ' ';
  }
}
